<?php
/*------------------------------------------------------------------------
# mod_jo_newslider - JO News Slider for Joomla 1.6, 1.7, 2.5 Module
# -----------------------------------------------------------------------
# author: http://www.joomcore.com
# copyright Copyright (C) 2012 Joomcore.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomcore.com
# Technical Support:  Forum - http://www.joomcore.com/Support
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once JPATH_SITE.'/components/com_content/helpers/route.php';

jimport('joomla.application.component.model');
if($params->get('loadmootools') == 1){
	JModel::addIncludePath(JPATH_SITE.'/components/com_content/models');
}else{
	JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_content/models');
}

abstract class modJONewsSLiderHelper
{
	public static function getList(&$params)
	{
		// Get the dbo
		$db = JFactory::getDbo();

		// Get an instance of the generic articles model
		if($params->get('loadmootools') == 1) {
			$model = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
		} else {
			$model = JModelLegacy::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
		}
		

		// Set application parameters in model
		$app = JFactory::getApplication();
		$appParams = $app->getParams();
		$model->setState('params', $appParams);

		// Set the filters based on the module params
		$model->setState('list.start', 0);
		$model->setState('list.limit', (int) $params->get('count', 3));
		$model->setState('filter.published', 1);

		// Access filter
		$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$model->setState('filter.access', $access);

		// Category filter
		$model->setState('filter.category_id', $params->get('catid', array()));

		// User filter
		$userId = JFactory::getUser()->get('id');
		switch ($params->get('user_id'))
		{
			case 'by_me':
				$model->setState('filter.author_id', (int) $userId);
				break;
			case 'not_me':
				$model->setState('filter.author_id', $userId);
				$model->setState('filter.author_id.include', false);
				break;

			case '0':
				break;

			default:
				$model->setState('filter.author_id', (int) $params->get('user_id'));
				break;
		}

		// Filter by language
		$model->setState('filter.language',$app->getLanguageFilter());

		//  Featured switch
		switch ($params->get('show_featured'))
		{
			case '1':
				$model->setState('filter.featured', 'only');
				break;
			case '0':
				$model->setState('filter.featured', 'hide');
				break;
			default:
				$model->setState('filter.featured', 'show');
				break;
		}

		// Set ordering
		$order_map = array(
			'm_dsc' => 'a.modified DESC, a.created',
			'mc_dsc' => 'CASE WHEN (a.modified = '.$db->quote($db->getNullDate()).') THEN a.created ELSE a.modified END',
			'c_dsc' => 'a.created',
			'p_dsc' => 'a.publish_up',
			'h_dsc' =>  'a.hits'
		);
		$ordering = JArrayHelper::getValue($order_map, $params->get('ordering'), 'a.publish_up');
		$dir = 'DESC';
		
		$model->setState('list.ordering', $ordering);
		$model->setState('list.direction', $dir);
		
		$items = $model->getItems();
		
		foreach ($items as &$item) 
		{
			$item->slug = $item->id.':'.$item->alias;
			$item->catslug = $item->catid.':'.$item->category_alias;
			
			if ($access || in_array($item->access, $authorised))
			{
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
			}
			else {
				$item->link = JRoute::_('index.php?option=com_user&view=login');
			}
			//$item->title = htmlspecialchars( $item->title );
			$item->content= strip_tags(preg_replace('/<img([^>]+)>/i',"",$item->introtext));
			$item->content = substr($item->content, 0, $params->get('introtext_limit'));
			
			@preg_match_all('/img.+src="([^"]+)"/i', $item->introtext . $item->fulltext, $matches);
			if(empty($matches[1][0])){
				$item->images="";
			}else{
				$item->images= $matches [1] [0];
			}
			
			//Show images
			if($params->get('show_thumb')==1){
				if($item->images == ""){
					$item->image = '<img src="'.$params->get('directory_thumb_default').'" width="'.$params->get('width_thumb').'" alt="'.$item->title.'" />';
				}else{
					$item->image = '<img src="' .$item->images.'" width="'.$params->get('width_thumb').'" alt="'.$item->title.'" />'  ;    //show images
				}
			}
			$item->created_date = $item->created;
		}
		return $items;
	}
}